/**
 * The contents of this file are subject to the terms of the Common Development and
 * Distribution License (the License). You may not use this file except in compliance with the
 * License.
 *
 * You can obtain a copy of the License at legal/CDDLv1.0.txt. See the License for the
 * specific language governing permission and limitations under the License.
 *
 * When distributing Covered Software, include this CDDL Header Notice in each file and include
 * the License file at legal/CDDLv1.0.txt. If applicable, add the following below the CDDL
 * Header, with the fields enclosed by brackets [] replaced by your own identifying
 * information: "Portions copyright [year] [name of copyright owner]".
 *
 * Copyright 2015-2016 ForgeRock AS.
 */

define([
    "jquery",
    "lodash",
    "org/forgerock/commons/ui/common/components/Footer",
    "org/forgerock/commons/ui/common/main/Configuration",
    "org/forgerock/openidm/ui/common/delegates/InfoDelegate"
], function($, _, Footer, Configuration, InfoDelegate) {
    function isAdmin() {
        return Configuration.loggedUser && Configuration.loggedUser.has("roles") && _.indexOf(Configuration.loggedUser.uiroles, "ui-admin") > -1;
    }

    var Component = Footer.extend({
        getVersion: function() {
            return InfoDelegate.getVersion().then(function(data) {
                return data.productVersion + " (" + $.t("openidm.admin.revision") + ": " + data.productRevision + ")";
            });
        },
        showVersion: function() {
            return isAdmin();
        }
    });

    return new Component();
});
